<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta charset='UTF-8'>
    <meta name="author" content="Benjamin Verner">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="styles.css">
    <title>
    Slitherlink
    </title>
  </head>
  <body>
    <ul>
      <li class="menu"><a href="index.html">Úvod</a></li>
      <li class="menu"><a href="solver.html">SAT Solver</a></li>
      <li class="submenu">
        <a class="submenu-button">Konkrétní problémy</a>
        <div class="submenu-elements">
          <a href="pozorovani.html">Pozorování</a>
          <a href="sudoku.html">Sudoku</a>
          <a href="abc.html">Easy as ABC</a>
          <a href="logik.html">Logik</a>
          <a href="slitherlink.html">Slitherlink</a>
        </div>
      </li>
      <li class="menu"><a href="dokumentace.html">Technická dokumentace</a></li>
      <li class="menu"><a href="zaver.html">Závěr</a></li>
      <li class="menu"><a href="citace.html">Citace</a></li>
    </ul>
    <article>
      <h2 id="title">Slitherlink</h2>
      <img src="slitherlink_example.png" alt="Slitherlink" class="image">
      <section>
        <h3>Popis problému</h3>
        <p>Slithering je zadán také mřížkou, která však není vyplněná čárami - prakticky máme tečky jako rohy všech pozic, mezi kterými máme doplnit některé čáry sami. Na některých pozicích mřížky jsou zadaná čísla. Ta nám říkají, kolik čar musí být v jejich okolí. Navíc víme, že doplněné čáry nám musí dát cyklus.</p>
      </section>
      <section>
        <h3>Pravidla</h3>
        <p>Tento problém je zdánlivě o dost těžší než předcházející. Pravidlo čísel můžeme sice vytvořit použitím pozorování na začátku kapitoly (viz 3.0), problém je ale globalita pravidla o cyklu. Je prakticky nemožné vymyslet formuli, která by odpovídala pravidlu cyklu. </p>
        <p>Lze zajistit, že veškeré hrany budou součástí cyklu. Pro každý vrchol stačí zajistit, aby z něj vycházely buď dvě hrany, nebo žádná. To problém není, stačí použít začáteční pozorování (viz 3.0).
        Takto samozřejmě nezajistím, že cyklus bude pouze jeden. Pro zadání SAT Solver takto najde spoustu přijatelných řešení, z kterých pouze jedno bude správné. Proto bude potřeba podobně jako v Logiku funkce, která všechna vygenerovaní řešení zkontroluje, zda obsahují právě jeden cyklus. Na to stačí jednoduché prohledávání do hloubky. Ve chvíli, kdy dojdu po cyklu zpět do začátku jen zkontroluji, jestli jsem navštívil všechny hrany.</p>
      </section>
    </article>
  </body>
</html>
